import regex as re

def remove_whitespace(text):
    # we need to remove the whitespace that comes with the pretty-printed xml
    text = re.sub(r'\n *', ' ', text)
    while re.search(r'  ', text):
        text = re.sub(r'  ', ' ', text)
    # fix issues with whitespace before and after punctuation
    text = re.sub(r' ([.;,!?%:]) ', r'\1 ', text)
    # opening and closing punctutation, such as brackets
    text = re.sub(r'(\p{Ps}) ', r'\1', text)
    text = re.sub(r' (\p{Pe})', r'\1', text)
    # opening and closing quotes
    text = re.sub(r'(\p{Pi}) ', r'\1', text)
    text = re.sub(r' (\p{Pf})', r'\1', text)
    return text.strip()